Simple Makefile target helper https://pagure.io/mkit

mkit.sh 3.7KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161
  1. #!/bin/bash
  2. # MKit - simple install helper
  3. # See LICENSE file for copyright and license details.
  4. die() {
  5. #
  6. # Exit with message and non-zero exit status
  7. #
  8. echo "fatal: $*" >&2
  9. exit 4
  10. }
  11. mkit_import() {
  12. #
  13. # Import mkit module $1.sh
  14. #
  15. # Check for module, source it and die with reasonable message if needed.
  16. #
  17. local modname=$1
  18. local modpath
  19. modpath="$MKIT_DIR/include/$modname.sh"
  20. test -f "$modpath" || die "no such module: $modpath"
  21. bash -n "$modpath" || die "bad syntax: $modpath"
  22. #shellcheck disable=SC1090
  23. . "$modpath" || die "failed to import: $modname"
  24. }
  25. mkit_import build
  26. mkit_import deploy
  27. mkit_import release
  28. mkit_import ini
  29. _valid_targets() {
  30. #
  31. # List valid routes
  32. #
  33. echo build
  34. echo build_manpages
  35. echo clean
  36. echo debstuff
  37. echo dist
  38. echo install
  39. echo release_x
  40. echo release_y
  41. echo release_z
  42. echo rpmstuff
  43. echo uninstall
  44. echo vbump_x
  45. echo vbump_y
  46. echo vbump_z
  47. }
  48. debug() {
  49. #
  50. # Print debug message
  51. #
  52. $MKIT_DEBUG || return 0
  53. echo "MKIT_DEBUG: ${FUNCNAME[1]}()" "$@" >&2
  54. }
  55. debug_var() {
  56. #
  57. # Print debug message
  58. #
  59. $MKIT_DEBUG || return 0
  60. local __mkit_debug_var_name__ # variable name to debug
  61. for __mkit_debug_var_name__ in "$@"; do
  62. {
  63. echo -n "MKIT_DEBUG: ${FUNCNAME[1]}():"
  64. echo -n " $__mkit_debug_var_name__"
  65. echo -n "='${!__mkit_debug_var_name__}'"
  66. echo
  67. } >&2
  68. done
  69. }
  70. _compver() {
  71. #
  72. # True if version $1 matches our version
  73. #
  74. # If our x is 0, check first two fragments, otherwise check just
  75. # the x. Fragments must equal.
  76. #
  77. local their_ver=$1 # their version
  78. local our_x # our X
  79. local our_y # our Y
  80. local their_x # their X
  81. local their_y # their Y
  82. their_x=${their_ver%%.*}
  83. their_y=${their_ver##$their_x.}
  84. their_y=${their_y%%.*}
  85. our_x=${MKIT_VERSION%%.*}
  86. our_y=${MKIT_VERSION##$our_x.}
  87. our_y=${our_y%%.*}
  88. debug_var MKIT_VERSION our_x our_y their_ver their_x their_y
  89. test "$their_x" -eq "$our_x" || return 1
  90. test "$our_x" -eq 0 && {
  91. test "$their_y" = "$our_y"
  92. return $?
  93. }
  94. return 0
  95. }
  96. _chkiniversion() {
  97. #
  98. # Check if ini version is supported
  99. #
  100. # Look for "#mkit version=0.0.0" or similar in first or last
  101. # 3 lines of the file; then check if the version is supported.
  102. #
  103. local ver_line # line declaring version
  104. local their_ver # the declared version
  105. ver_line=$(
  106. {
  107. head -3 "$MKIT_INI"
  108. tail -3 "$MKIT_INI"
  109. } | grep -m 1 -E '^# *mkit +version *= *v?[0-9]+\.[0-9]+\.[0-9]+'
  110. )
  111. test -n "$ver_line" \
  112. || die "version mark ('#mkit version=x.y.z') not found in: $MKIT_INI"
  113. their_ver="$(tr -d '[:blank:]v' <<<"${ver_line##*=}")"
  114. _compver "$their_ver" \
  115. || die "bad mkit.ini version: $their_ver does not match $MKIT_VERSION"
  116. }
  117. mkit_init() {
  118. #
  119. # Do basic initialization
  120. #
  121. # Check for ini file and some variables
  122. #
  123. $MKIT_DRY && MKIT_DEBUG=true
  124. MKIT_PROJ_PKGNAME=$(ini 1value "project:pkgname")
  125. test -f "$MKIT_INI" || die "cannot find mkit.ini: $MKIT_INI"
  126. _chkiniversion
  127. test -n "$(tr -d '[:space:]' <<<"$MKIT_LOCAL")" \
  128. || die "MKIT_LOCAL must be non-blank: '$MKIT_LOCAL'"
  129. }
  130. route() {
  131. #
  132. # Call correct function based on $1
  133. #
  134. if _valid_targets | grep -qwx "^$1"; then
  135. "$1"
  136. else
  137. {
  138. echo "usage: $(basename "$0") TARGET"
  139. echo
  140. echo "valid targets:"
  141. _valid_targets | sed 's/^/ /'
  142. } >&2
  143. fi
  144. }
  145. warn() {
  146. #
  147. # Print warning message
  148. #
  149. echo "$@" >&2
  150. }